unit SettingForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls;

type
  TfrmSetting = class(TForm)
    PageControl: TPageControl;
    btnOK: TButton;
    btnCancel: TButton;
    tsJoypad1: TTabSheet;
    tsJoypad2: TTabSheet;
    Label1: TLabel;
    cb1UP: TComboBox;
    Label2: TLabel;
    cb1Left: TComboBox;
    Label3: TLabel;
    cb1right: TComboBox;
    Label4: TLabel;
    cb1down: TComboBox;
    Label5: TLabel;
    cb1A: TComboBox;
    Label6: TLabel;
    cb1B: TComboBox;
    Label8: TLabel;
    cb1Select: TComboBox;
    Label9: TLabel;
    cb1Start: TComboBox;
    tsScreen: TTabSheet;
    cbJoy1: TCheckBox;
    gbWindow: TGroupBox;
    rbNormal: TRadioButton;
    rbDouble: TRadioButton;
    Label7: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    cb2Up: TComboBox;
    cb2Left: TComboBox;
    cb2Right: TComboBox;
    cb2down: TComboBox;
    cb2A: TComboBox;
    cb2B: TComboBox;
    cb2Select: TComboBox;
    cb2Start: TComboBox;
    cbJoy2: TCheckBox;
    ckViewFreq: TCheckBox;
    rbFull: TRadioButton;
    Label10: TLabel;
    cbDisplay: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure rbNormalClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSetting: TfrmSetting;

implementation

uses NesForm, Registry;

{$R *.DFM}

procedure TfrmSetting.FormCreate(Sender: TObject);
var
  i : integer;
begin
  { initialize Joypad }
  cb1UP.Items.AddObject('BACK', TObject(VK_BACK));
  cb1UP.Items.AddObject('TAB', TObject(VK_TAB));
  cb1UP.Items.AddObject('CLEAR', TObject(VK_CLEAR));
  cb1UP.Items.AddObject('RETURN', TObject(VK_RETURN));
  cb1UP.Items.AddObject('SHIFT', TObject(VK_SHIFT));
  cb1UP.Items.AddObject('CONTROL', TObject(VK_CONTROL));
  cb1UP.Items.AddObject('ESCAPE', TObject(VK_ESCAPE));
  cb1UP.Items.AddObject('SPACE', TObject(VK_SPACE));
  cb1UP.Items.AddObject('PAG UP', TObject(VK_PRIOR));
  cb1UP.Items.AddObject('PAG DOWN', TObject(VK_NEXT));
  cb1UP.Items.AddObject('END', TObject(VK_END));
  cb1UP.Items.AddObject('HOME', TObject(VK_HOME));
  cb1UP.Items.AddObject('LEFT', TObject(VK_LEFT));
  cb1UP.Items.AddObject('UP', TObject(VK_UP));
  cb1UP.Items.AddObject('RIGHT', TObject(VK_RIGHT));
  cb1UP.Items.AddObject('DOWN', TObject(VK_DOWN));
  cb1UP.Items.AddObject('NUMPAD 0', TObject(VK_NUMPAD0));
  cb1UP.Items.AddObject('NUMPAD 1', TObject(VK_NUMPAD1));
  cb1UP.Items.AddObject('NUMPAD 2', TObject(VK_NUMPAD2));
  cb1UP.Items.AddObject('NUMPAD 3', TObject(VK_NUMPAD3));
  cb1UP.Items.AddObject('NUMPAD 4', TObject(VK_NUMPAD4));
  cb1UP.Items.AddObject('NUMPAD 5', TObject(VK_NUMPAD5));
  cb1UP.Items.AddObject('NUMPAD 6', TObject(VK_NUMPAD6));
  cb1UP.Items.AddObject('NUMPAD 7', TObject(VK_NUMPAD7));
  cb1UP.Items.AddObject('NUMPAD 8', TObject(VK_NUMPAD8));
  cb1UP.Items.AddObject('NUMPAD 9', TObject(VK_NUMPAD9));
  cb1Down.Items.Assign(cb1UP.Items);
  cb1Left.Items.Assign(cb1UP.Items);
  cb1Right.Items.Assign(cb1UP.Items);
  cb1A.Items.Assign(cb1UP.Items);
  cb1B.Items.Assign(cb1UP.Items);
  cb1Start.Items.Assign(cb1UP.Items);
  cb1Select.Items.Assign(cb1UP.Items);
  cb2Up.Items.Assign(cb1UP.Items);
  cb2Down.Items.Assign(cb1UP.Items);
  cb2Left.Items.Assign(cb1UP.Items);
  cb2Right.Items.Assign(cb1UP.Items);
  cb2A.Items.Assign(cb1UP.Items);
  cb2B.Items.Assign(cb1UP.Items);
  cb2Start.Items.Assign(cb1UP.Items);
  cb2Select.Items.Assign(cb1UP.Items);
  { initialize screen modes }
  if not frmNES.DXDraw.Initialized then
    frmNES.DXDraw.Initialize;
  for i:=0 to frmNES.DXDraw.Display.Count-1 do
    cbDisplay.Items.Add(Format('%dx%dx%d', [frmNES.DXDraw.Display.Modes[i].Width,
        frmNES.DXDraw.Display.Modes[i].Height, frmNES.DXDraw.Display.Modes[i].BitCount]));
  if not frmNES.DXDraw.Initialized then
    frmNES.DXDraw.Finalize;
  { load default values }
  { Joypad 1 }
  cb1Up.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_UP));
  cb1Down.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_DOWN));
  cb1Left.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_LEFT));
  cb1Right.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_RIGHT));
  cb1A.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_A));
  cb1B.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_B));
  cb1Start.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_START));
  cb1Select.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON1_SELECT));
  cbJoy1.Checked := frmNES.BUTTON1_ENABLED;
  { Joypad 2 }
  cb2Up.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_UP));
  cb2Down.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_DOWN));
  cb2Left.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_LEFT));
  cb2Right.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_RIGHT));
  cb2A.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_A));
  cb2B.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_B));
  cb2Start.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_START));
  cb2Select.ItemIndex := cb1Up.Items.IndexOfObject(TObject(frmNES.BUTTON2_SELECT));
  cbJoy2.Checked := frmNES.BUTTON2_ENABLED;
  { Screen }
  case frmNES.WIN_MODE of
    0 : rbNormal.Checked := true;
    1 : rbDouble.Checked := true;
    2 : rbFull.Checked   := true;
  end;
  i := cbDisplay.Items.IndexOf(frmNES.SCREEN_MODE);
  if i<>-1 then
    cbDisplay.ItemIndex := i
  else
    cbDisplay.ItemIndex := 0;
  { View frequency }
  ckViewFreq.Checked := frmNES.ViewFreq;
end;

procedure TfrmSetting.btnOKClick(Sender: TObject);
begin
  { Joypad 1 }
  frmNES.BUTTON1_UP := Integer(cb1Up.Items.Objects[cb1Up.ItemIndex]);
  frmNES.BUTTON1_DOWN := Integer(cb1Up.Items.Objects[cb1Down.ItemIndex]);
  frmNES.BUTTON1_LEFT := Integer(cb1Up.Items.Objects[cb1Left.ItemIndex]);
  frmNES.BUTTON1_RIGHT := Integer(cb1Up.Items.Objects[cb1Right.ItemIndex]);
  frmNES.BUTTON1_A    := Integer(cb1Up.Items.Objects[cb1A.ItemIndex]);
  frmNES.BUTTON1_B    := Integer(cb1Up.Items.Objects[cb1B.ItemIndex]);
  frmNES.BUTTON1_START := Integer(cb1Up.Items.Objects[cb1Start.ItemIndex]);
  frmNES.BUTTON1_SELECT:= Integer(cb1Up.Items.Objects[cb1Select.ItemIndex]);
  frmNES.BUTTON1_ENABLED := cbJoy1.Checked;
  { Joypad 2 }
  frmNES.BUTTON2_UP := Integer(cb1Up.Items.Objects[cb2Up.ItemIndex]);
  frmNES.BUTTON2_DOWN := Integer(cb1Up.Items.Objects[cb2Down.ItemIndex]);
  frmNES.BUTTON2_LEFT := Integer(cb1Up.Items.Objects[cb2Left.ItemIndex]);
  frmNES.BUTTON2_RIGHT := Integer(cb1Up.Items.Objects[cb2Right.ItemIndex]);
  frmNES.BUTTON2_A    := Integer(cb1Up.Items.Objects[cb2A.ItemIndex]);
  frmNES.BUTTON2_B    := Integer(cb1Up.Items.Objects[cb2B.ItemIndex]);
  frmNES.BUTTON2_START := Integer(cb1Up.Items.Objects[cb2Start.ItemIndex]);
  frmNES.BUTTON2_SELECT:= Integer(cb1Up.Items.Objects[cb2Select.ItemIndex]);
  frmNES.BUTTON2_ENABLED := cbJoy2.Checked;
  { Screen }
  if rbNormal.Checked then
    frmNES.WIN_MODE := 0
  else if rbDouble.Checked then
    frmNES.WIN_MODE := 1
  else if rbFull.Checked then
  begin
    frmNES.WIN_MODE := 2;
    frmNES.SCREEN_MODE := cbDisplay.Text;
  end;
  ModalResult := mrOK;
end;

procedure TfrmSetting.rbNormalClick(Sender: TObject);
begin
  cbDisplay.Enabled := TRadioButton(Sender).Name = 'rbFull';
end;

end.
